<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'zh',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => '纤程',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => '语言参考',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => '扩展（extend）异常处理类',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => '生成器',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'zh',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">纤程</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">纤程概述</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   纤程（Fiber）表示一组有完整栈、可中断的功能。
   纤程可以在调用堆栈中的任何位置被挂起，在纤程内暂停执行，直到稍后恢复。
  </p>
  <p class="para">
   纤程可以暂停整个执行堆栈，所以该函数的直接调用者不需要改变调用这个函数的方式。
  </p>
  <p class="para">
   你可以在调用堆栈的任意地方使用 <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> 
   中断执行（也就是说，<span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> 
   的调用位置可以在一个深度嵌套的函数中，甚至可以不存在）。
  </p>
  <p class="para">
   与无栈的 <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span> 不同, 每一个
   <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> 拥有自己的调用栈，并允许在一个深度前度的函数调用中将它们暂停。
   声明了中断（interruption）点的函数（即调用 <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>）
   不需要改变自己的返回类型，不像使用 <a href="language.generators.syntax.php#control-structures.yield" class="link"><code class="literal">yield</code></a> 一样需要返回一个
   <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span> 实例。
  </p>
  <p class="para">
   纤程可以在任意函数调用中被暂停，包括那些在 PHP VM 中被调用的函数。
   例如被用于 <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span> 的函数或者提供
   <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span> 对象以被 <a href="control-structures.foreach.php" class="link"><code class="literal">foreach</code></a> 调用的方法。
  </p>
  <p class="para">
   纤程一旦被暂停，可以使用 <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span> 
   传递任意值、或者使用 <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span> 
   向纤程抛出一个异常以恢复运行。这个值或者异常将会在
   <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> 中被返回（抛出）。
  </p>
  <blockquote class="note"><p><strong class="note">注意</strong>: 
   <span class="simpara">
    在 PHP 8.4.0 之前，不允许在对象<a href="language.oop5.decon.php#language.oop5.decon.destructor" class="link">析构方法</a>执行期间切换纤程。
   </span>
  </p></blockquote>

  <div class="example" id="language.fiber.example.basic">
   <p><strong>示例 #1 基础用法</strong></p>
   <div class="example-contents">
    <div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Value used to resume fiber: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Value from fiber suspending: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>以上示例会输出：</p></div>
   <div class="example-contents screen">
    <div class="cdata"><pre>
Value from fiber suspending: fiber
Value used to resume fiber: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>